package org.greenstone.gsdl3.gs3build.doctypes;

import java.sql.SQLException;
import java.sql.Statement;
import java.sql.ResultSet;
import java.net.URL;

import org.greenstone.gsdl3.gs3build.database.GS3SQLConnection;

public class DocumentFactory {
    
    public static AbstractDocument createDocument(String type, DocumentID id) {
	
	if (type.equals(HTMLDocument.HTML_DOCUMENT_TYPE)) {
	    return new HTMLDocument(id);
	} else if (type.equals(TextDocument.TEXT_DOCUMENT_TYPE)) {
	    return new TextDocument(id);
	} else if (type.equals(JPEGDocument.JPEG_DOCUMENT_TYPE)) {
	    return new JPEGDocument(id);
	} else if (type.equals(IndexDocument.INDEX_DOCUMENT_TYPE)) {
	    return new IndexDocument(id);
	} else if (type.equals(MetadataDocument.METADATA_DOCUMENT_TYPE)) {
	    return new MetadataDocument(id);
	} else if (type.equals(METSDocument.METS_DOCUMENT_TYPE)) {
	    return new METSDocument(id);
	} else if (type.equals(GMLDocument.GML_DOCUMENT_TYPE)) {
	    return new GMLDocument(id);
	}
	
	/*
	  else if (type.equals(ExtXMLDocument.EXTXML_DOCUMENT_TYPE))
	  { return new ExtXMLDocument(id);
	  }*/
	return null;
    }
    public static AbstractDocument createDocument(String type, URL url) {
	
	if (type.equals(HTMLDocument.HTML_DOCUMENT_TYPE)) {
	    return new HTMLDocument(url);
	} else if (type.equals(TextDocument.TEXT_DOCUMENT_TYPE)) {
	    return new TextDocument(url);
	} else if (type.equals(JPEGDocument.JPEG_DOCUMENT_TYPE)) {
	    return new JPEGDocument(url);
	} else if (type.equals(IndexDocument.INDEX_DOCUMENT_TYPE)) {
	    return new IndexDocument(url);
	} else if (type.equals(MetadataDocument.METADATA_DOCUMENT_TYPE)) {
	    return new MetadataDocument(url);
	} else if (type.equals(METSDocument.METS_DOCUMENT_TYPE)) {
	    return new METSDocument(url);
	} else if (type.equals(GMLDocument.GML_DOCUMENT_TYPE)) {
	    return new GMLDocument(url);
	}
	
	/*
	  else if (type.equals(ExtXMLDocument.EXTXML_DOCUMENT_TYPE))
	  { return new ExtXMLDocument(id);
	  }*/
	return null;
    }
    
  public static DocumentInterface readSQLDocument(GS3SQLConnection connection, DocumentID id)
  {
    String query = "SELECT * FROM document WHERE DocID=\""+id.toString()+"\";";
    try {
	Statement statement = connection.createStatement();
	ResultSet results = statement.executeQuery(query);
	
	DocumentInterface di = null;
	if (results.first()) {
	    di = AbstractDocument.readSQL(connection, results);
	}
	statement.close();
	return di;
    }
    catch (SQLException sqlEx) {
      System.err.println("AbstractDocument.readSQLDocument():"+sqlEx);
    }
    return null;
  }
}
